﻿Type=StaticCode
Version=4
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Static code module
Sub Process_Globals
	Private fx As JFX
	Private lblTitle, lblTransfer, lblTransferFrom, lblTransferTo As Label
	Private btnCancel As Button
	Private btnSelect, btnTransfer As Button
	Private btnUpdate As Button
	Private tvData As TableView
	Private txtName As TextField
	Private pnTransfer As Pane
	Private cboTransferFrom, cboTransferTo As ComboBox
	Dim Action As String
	Dim frmAddType As Form
	Dim strQuery, strText As String
	Dim ID As Int:ID=0
	Dim Toast As ToastMessageShow
	Dim SQL1 As SQL
End Sub

Sub TypeStorLoad
	SQL1.InitializeSQLite(File.DirApp, "SCM.db3", True)
	'Toast.ToastNotificationOwner = Main.frmProvUpdate
			Toast.Initialize("Toast")
			Toast.ToastIconSize32x32
			Toast.ToastDuration = 6 'Toast.TOAST_LONG_DELAY
			Toast.ToastTextLocation = Toast.TEXT_CENTER
			Toast.ToastLocation= Toast.TOAST_CENTER_RIGHT
			Toast.ToastMessageColor = fx.Colors.Green
			
			If  	frmAddType.IsInitialized=False Then
					frmAddType.Initialize("frmAddType", 530, 650)
					frmAddType.SetFormStyle("UNIFIED")
					frmAddType.RootPane.LoadLayout("TypeStorUpdate")
			End If
			tvData.SetColumnWidth(0,-1)
			tvData.SetColumnWidth(1,200)
			
			If Action="Type" Then
						lblTitle.Text="Add or Delete an Object Type (Tertiary Class'n)"
						btnSelect.Text="Select an Object Type..."	
					strQuery = "Select _id, TertiaryClass from Tertiary Order By TertiaryClass;"
					DBUtils.ExecuteTableview(SQL1,strQuery,Null,0,tvData)
					pnTransfer.Visible=True
					cboTransferFrom.Visible=False:cboTransferTo.Visible=False
					lblTransfer.Visible=False:lblTransferFrom.visible=False:lblTransferTo.visible=False:btnTransfer.visible=False
			Else
				lblTitle.Text="Add or Delete a Storage or Loan Place"
				btnSelect.Text="Select a Storage/Loan place...."
				strQuery = "SELECT _id, StoragePlace from Storage Order By StoragePlace;"
					DBUtils.ExecuteTableview(SQL1,strQuery,Null,0,tvData)
					pnTransfer.Visible=False
					DBUtils.ExecuteList(SQL1, "SELECT storageplace FROM storage order by storageplace", Null, 0, cboTransferFrom.Items)			
					DBUtils.ExecuteList(SQL1, "SELECT storageplace FROM storage order by storageplace", Null, 0, cboTransferTo.Items)	
					cboTransferFrom.Value="Select..."
					cboTransferTo.Value="Select..."
					cboTransferFrom.Visible=True:cboTransferTo.Visible=True
					lblTransfer.Visible=True:lblTransferFrom.visible=True:lblTransferTo.visible=True:btnTransfer.visible=True

					
			End If
			tvData.SetColumnWidth(0,-1)
			tvData.SetColumnWidth(1,200)
	frmAddType.show
	
End Sub
Sub btnTransfer_MouseClicked (EventData As MouseEvent)

If cboTransferFrom.value="" Or cboTransferTo.value="" Then Return
If cboTransferFrom.value="Select..." Or cboTransferTo.Value="Select..." Then Return
Dim Res As Int
Res= fx.Msgbox2(Null,"Please confirm transfer of items" & CRLF & "From:" & cboTransferFrom.value & CRLF & "To:" & cboTransferTo.value,"Confirm Deletion","Yes", "", "No", fx.MSGBOX_WARNING)
	If Res = fx.DialogResponse.POSITIVE Then
Dim mp As Map
mp.initialize
mp.Put("storage",cboTransferFrom.Value)
DBUtils.UpdateRecord(SQL1,"Objects","storage",cboTransferTo.Value,mp)
Toast.ToastShow("Items transferred from: " & cboTransferFrom.value &" to " & cboTransferTo.Value)

'update the current record..just in case its been change
ObjectAdd.transferupdate

	
	
Else
Return
End If
End Sub


Sub btnUpdate_MouseClicked (EventData As MouseEvent)

Dim mp As Map
mp.Initialize
Dim maps As List
maps.Initialize
Dim btn As Button
btn=Sender
Log (btn.Tag)
'add a new record
If btn.Tag="1" Then
	If txtName.Text ="" Then 
		Return
	Else
		btnUpdate.Text="Add record: " & txtName.text
		End If
Log(Action)
		If Action="Type" Then		
				mp.Put("_id",Null)
				mp.Put("TertiaryClass",txtName.Text)
				maps.Add(mp)
				DBUtils.InsertMaps(SQL1, "Tertiary", maps)
				Toast.ToastShow("Tertiary Class: " & txtName.Text &" added.")
		Else
				mp.Put("_id",Null)
				mp.Put("StoragePlace",txtName.Text)
				maps.Add(mp)
				DBUtils.InsertMaps(SQL1, "Storage", maps)
				Toast.ToastShow("Storage Place: " & txtName.Text &" added.")
		End If
		txtName.Text=""
		btnUpdate.Text="Add New Record"
		TypeStorLoad
'Cancel pressed - reset the values			
Else if btn.Tag="2" Then
txtName.Text=""
frmAddType.close
Return
Else
'Delete pressed

If btnSelect.Text="Select an Object Type..." Then Return
			mp.Put("_id",ID)
			Toast.ToastMessageColor = fx.Colors.Yellow
			If Action="Type" Then
						DBUtils.DeleteRecord(SQL1,"Tertiary",mp)
						Toast.ToastShow("Object Type: " & strText &" deleted..")
										Else 
						DBUtils.DeleteRecord(SQL1,"Storage",mp)
						Toast.ToastShow("Storage Place: " & strText &" deleted..")
						
			End If
			End If
		DBUtils.ExecuteList(SQL1, "SELECT tertiaryclass FROM Tertiary order by tertiaryclass", Null, 0, ObjectAdd.cboObjectType.Items)	
		DBUtils.ExecuteList(SQL1, "SELECT storageplace FROM storage order by storageplace", Null, 0, ObjectAdd.cboStorage.Items)		
		TypeStorLoad
End Sub


 Sub tvData_SelectedRowChanged(Index As Int, Row() As Object)
	If Index = -1 Then Return
	ID=Row(0)
	Dim m As Map
	m.initialize
	If Action="Type" Then
	strQuery="SELECT _id,TertiaryClass from Tertiary where _id="&ID	
			m = DBUtils.ExecuteMap(SQL1, strQuery, Null)
			btnSelect.Text="Delete: " & m.Get("tertiaryclass")
			strText = m.Get("tertiaryclass")
	Else
	strQuery="SELECT _id, StoragePlace from Storage where _id="	&ID
			m = DBUtils.ExecuteMap(SQL1, strQuery, Null)	
			btnSelect.Text="Delete: " & m.Get("storageplace") 
			strText=m.Get("storageplace") 

	End If
	
End Sub
		
