﻿Type=StaticCode
Version=4
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Static code module
Sub Process_Globals
	Private fx As JFX
	
	Dim PrimaryText As String
	Dim SecondText As String
	Dim PrimaryID, SecondID, Action As Int: Action=0:PrimaryID=0:SecondID=0
	Dim lstTable As List
	Dim val() As String

	Private btnAdd, btnCancel,btnPrimary,btnSecond,btnUpdate1 As Button
	Private btnCancel1 As Button
	Private btnDelete As Button
	Private btnEdit As Button
	Private btnUpdate As Button
	Private lblPrimary As Label
	Private LblPrimary1 As Label
	Private lblSecond,lblSecond1,lblTitle As Label
	Private paneEdit As Pane
	Private paneUpdate As Pane
	Private tvPrimary As TableView
	Private tvSecond As TableView
	
	Dim strQuery As String
	Dim PrimaryID As Int:PrimaryID=0
	Dim SecondID As Int:SecondID=0
	Dim SQL1 As SQL
	Dim ClassnSelect As Form
	Private lbPrimary As Label
	Private lbSecond As Label
	Private txtPrimary As TextField
	Private txtSecond As TextField
	Private Toast As ToastMessageShow
	
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	
	Dim lblPrimary,LblPrimary1, lblSecond, lblSecond1, lbPrimary, lbSecond As Label
	Dim paneUpdate As Pane
	Dim txtPrimary,txtSecond As TextField
	Dim btnPrimary, btnSecond As Button
	Dim btnUpdate1 As Button
	Dim btnUpdate As Button
	
End Sub

Sub ClassnStart
	
	'load the layout file created with the visual designer	
	If  	ClassnSelect.Isinitialized = False Then
			ClassnSelect.Initialize("ClassnSelect", 475,575)
			ClassnSelect.SetFormStyle("UNIFIED")
			ClassnSelect.RootPane.LoadLayout("ClassnUpdate")
			
			SQL1.InitializeSQLite(File.DirApp, "SCM.db3", True)
					
			Toast.Initialize("Toast")
			Toast.ToastIconSize32x32
			Toast.ToastDuration = 6 'Toast.TOAST_LONG_DELAY
			Toast.ToastTextLocation = Toast.TEXT_CENTER
			Toast.ToastLocation= Toast.TOAST_CENTER_RIGHT
			Toast.ToastMessageColor = fx.Colors.Green
			
	End If
			btnPrimary.Visible=False
			btnSecond.Visible=False
			lblTitle.text="Manage Classifications for " & ObjectAdd.txtName.text
	
		showClassn
		ClassnSelect.Show
End Sub

Sub showClassn

'primary classn's
strQuery="SELECT _id [ID], PrimaryClassText [Primary Classification] FROM PrimaryClass ORDER BY PrimaryClassText ASC;"
	'load tableview
	DBUtils.ExecuteTableview(SQL1,strQuery,Null,0,tvPrimary)
		tvPrimary.SetColumnvisible(0,False)
		tvPrimary.SetColumnWidth(1,400)
'reset to original value
	tvSecond.Visible = False
	lblSecond.Text="Secondary Classifications"
	btnPrimary.Text="Primary Classification"
	btnSecond.Text="Secondary Classification"
	LblPrimary1.text=""
	
End Sub

Sub tvPrimary_SelectedRowChanged(Index As Int, Row() As Object)
     
	  If Index = -1 Then Return
	  	LogDebug(PrimaryID):PrimaryID=Row(0)
		strQuery="SELECT * FROM PrimaryClass where _id ="& PrimaryID &";"
		Dim m As Map
		m = DBUtils.ExecuteMap(SQL1, strQuery, Null)
		'Display data and store for Significance
			PrimaryID = m.Get("_id")
			PrimaryText=m.Get("primaryclasstext") 
		lblPrimary.Text=PrimaryText& " Selected"
		btnPrimary.Text="Primary Classn: " & PrimaryText
		btnSecond.Text="Select Secondary Classification"
		LblPrimary1.Text=PrimaryText:txtPrimary.text=PrimaryText
		lblSecond.Text="Select Secondary Classification"
		strQuery="SELECT   _id [ID#], SecondClassText [Secondary Classification], PrimaryClassID FROM SecondClass WHERE PrimaryClassID=" & PrimaryID & " ORDER BY SecondClassText ASC;"
		DBUtils.ExecuteTableview(SQL1,strQuery,Null,0,tvSecond)
		tvSecond.SetColumnvisible(0,False)
		tvSecond.SetColumnWidth(1,400)
		tvSecond.SetColumnVisible(2,False)
		txtPrimary.Text=PrimaryText:txtPrimary.Visible=False:lbPrimary.VISIBLE=False
		lbSecond.Visible=False
		tvSecond.Visible=True
		tvSecond_SelectedRowChanged(Index,Row)
End Sub

Sub tvSecond_SelectedRowChanged(Index As Int, Row() As Object)
	
	If tvSecond.SelectedRow < 0 Then Return
' Get the cell values from the selected row and assignto the Row Object
		Dim Row() As Object = tvSecond.SelectedRowValues
		SecondText=Row(1)
		SecondID=Row(0)
			lblSecond.Text=SecondText & "  Selected"
			lblSecond1.Text=SecondText
			btnSecond.Text="Secondary Classn: " & SecondText				
			paneEdit.Visible=True	
			txtSecond.Text=SecondText	
End Sub

Sub btnUpdate_Action
	'existing Classifications to be updated
			paneUpdate.Visible=True
			LblPrimary1.text=PrimaryText
			lblSecond1.text=SecondText
			txtPrimary.text=PrimaryText
			txtSecond.text=SecondText
			btnPrimary.Tag=1
			btnSecond.Tag=5	
End Sub

Sub btnEdit_Action
	'edit the Primary or Secondary classification
				btnPrimary.Text="Edit "& PrimaryText
				btnPrimary.Tag=2
				btnSecond.Text="Edit " & SecondText
				btnSecond.Tag=6
				btnPrimary.Visible=True
				btnSecond.Visible=True
				txtPrimary.Text=PrimaryText:txtSecond.text=SecondText
				txtPrimary.Visible=True:txtSecond.visible=True
				lbPrimary.Visible=True:lbSecond.visible=True		
End Sub

Sub btnDelete_Action
	'Delete the Primary or Secondary classification
	'Deleting a Primary classification deletes all associated secondary values 
				btnPrimary.text="Delete " & PrimaryText
				btnPrimary.Tag=3
				btnSecond.Text= "Delete " & SecondText
				btnSecond.Tag=7
				btnPrimary.Visible=True
				btnSecond.Visible=True
				txtPrimary.Visible=False:txtSecond.visible=False
				lbPrimary.Visible=False:lbSecond.visible=False
	
End Sub

Sub btnAdd_Action
	'Add a new primary or secondary classification
				btnPrimary.Text= "Add New Primary Classification"
				btnPrimary.Tag=4
				btnSecond.Text="Add Secondary Class'n for " & PrimaryText
				btnSecond.Tag=8
				btnPrimary.Visible=True
				btnSecond.Visible=True
				txtPrimary.Visible=True:txtSecond.visible=True
				lbPrimary.Visible=True:lbSecond.visible=True
End Sub


Sub btncancel_Action
	'exit the classification form
	ClassnSelect.Close
End Sub

Sub btncancel1_Action
	'exit the update process
	paneUpdate.Visible=False
End Sub

Sub btnPrimary_Action
'handles btnPrimary Edit Add Delete
'
			Dim mp As Map
			mp.Initialize
			Dim maps As List
			maps.Initialize
			Action=btnPrimary.tag
			PrimaryText=txtPrimary.Text
LogDebug(Action)
			Select Action	
			Case 1
				paneUpdate.Visible=True
			Case 2	
			'edit primary text
			LogDebug(PrimaryText)
				mp.Put("_id",PrimaryID)
				DBUtils.UpdateRecord(SQL1,"PrimaryClass","PrimaryClassText",PrimaryText,mp)
				Toast.ToastShow("Edited Primary Classification: " & PrimaryText)
				Case 3
			'delete primaryclass..and second classes
				 mp.Put("_id",PrimaryID)
				 maps.Add(mp)
				DBUtils.DeleteRecord(SQL1,"PrimaryClass",mp)
				Toast.ToastShow("Deleted Primary Classification: "&PrimaryText)
				mp.Clear
				mp.Put("PrimaryClassID",PrimaryID)
				DBUtils.DeleteRecord(SQL1,"SecondClass",mp)
				Toast.ToastShow("Deleted all Secondary Classifications for :"&PrimaryText)
				'reload tblviews
				PrimaryID=0
				SecondID=0
				showClassn

				Case 4
			'add a primary text
					mp.clear
				maps.Clear
				mp.Put("_id",Null)
				mp.Put("PrimaryClassText",PrimaryText.ToUpperCase)
				maps.Add(mp)
				DBUtils.InsertMaps(SQL1,"PrimaryClass",maps)
				strQuery="Select  _id as 'ID#', PrimaryClassText AS 'Primary Classification' FROM PrimaryClass ORDER BY _id DESC;"
				lstTable=DBUtils.ExecuteMemoryTable(SQL1,strQuery,Null,0)
				Dim row As Int
				val = lstTable.Get(row)
				PrimaryID=val(0)
				PrimaryText=val(1)
				showClassn
				Toast.ToastShow("Added New Primary Classification: "&PrimaryText)
			Case Else
				Toast.ToastShow("Select a PRIMARY and SECONDARY and an action (eg EDIT) first.")
			End Select
End Sub

Sub btnSecond_Action
'edit Seconday edit add delete	
			Dim mp As Map
			mp.Initialize
			Dim maps As List
			maps.Initialize
			Action=btnSecond.tag
			SecondText=txtSecond.Text
			Select Action

		Case 5
			'update
			paneUpdate.Visible=True
			lblPrimary.Text=PrimaryText
			lblSecond.Text=SecondText
		Case 6
			'edit Second Class
			lblPrimary.Text=SecondText
			mp.Put("_id",SecondID)
			DBUtils.UpdateRecord(SQL1,"SecondClass","SecondClassText",SecondText,mp)
			Toast.ToastShow("Edited..."&SecondText)
		Case 7	
		'delete second class
			mp.Put("_id",SecondID)
			DBUtils.DeleteRecord(SQL1,"SecondClass",mp)
				Toast.ToastShow("Deleted Secondary Classsification: "&SecondText)
				'PrimaryID=0
			SecondID=0
			
		Case 8
			'add new second class
			lblPrimary.Text=SecondText
			SecondText=SecondText.ToUpperCase
			SecondText=SecondText.SubString2(0,1)&SecondText.SubString(1).ToLowerCase 
			mp.Put("_id",Null)
			mp.Put("SecondClassText",SecondText)
			mp.Put("PrimaryClassID",PrimaryID)
			maps.Add(mp)
			DBUtils.InsertMaps(SQL1,"SecondClass",maps)
			Toast.ToastShow("Added..."&SecondText)


End Select
showClassn
End Sub

Sub btnUpdate1_Action
	'update the selected object record and closes the form
	If PrimaryID=0 Or SecondID=0 Then
			Toast.ToastShow("Please Select a Primary and Secondary Classification")
			Return
		Else
			'return form ClassnUpdate
			ObjectAdd.txtPrimaryClass.text=PrimaryText
			ObjectAdd.txtSecondClass.text=SecondText
			Toast.ToastShow("Please save the record to retain the new Classifications...")	
			ClassnSelect.close
		End If
End Sub
 


