﻿Type=StaticCode
Version=4
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Static code module
Sub Process_Globals
	Private fx As JFX
	
	Private btnCancel As Button
	Private btnUpdate As Button
	Private lblEmail As Label
	Private lblEvalTeam As Label
	Private lblOrganisation As Label
	Private lblPrefix As Label
	Private lblTitle As Label
	Private txtEmail As TextField
	Private txtEvalTeam As TextField
	Private txtOrganisation As TextField
	Private txtUnits As TextField
	Private PaneUnits As Pane
	Private rbMM,rbIn As RadioButton
	Public txtPrefix As TextField
	Dim Toast As ToastMessageShow
	Dim strQuery As String
	Dim LUnits As List
	Dim strUnits As String
	Dim SQL1 As SQL
	Dim frmSetUp As Form
	
	
End Sub

Sub LoadSetup
			
			If  	frmSetUp.IsInitialized=False Then
					frmSetUp.Initialize("frmSetup", 530, 300)
					frmSetUp.SetFormStyle("UNIFIED")
					frmSetUp.RootPane.LoadLayout("Setup")
					
					SQL1.InitializeSQLite(File.DirApp, "SCM.db3",False)
	
					Toast.Initialize("Toast")
					Toast.ToastIconSize32x32
					Toast.ToastDuration = 6 'Toast.TOAST_LONG_DELAY
					Toast.ToastTextLocation = Toast.TEXT_CENTER
					Toast.ToastLocation= Toast.TOAST_CENTER_RIGHT
					Toast.ToastMessageColor = fx.Colors.Green
					
			End If
			
			'load data
			Dim m As Map
	strQuery="SELECT * FROM Setup"
	Dim m As Map
	m.Initialize
	m = DBUtils.ExecuteMap(SQL1, strQuery, Null)
	LogDebug(m)
	
		'Display data and store for Significance
		txtOrganisation.Text = m.Get("organisation")                
		txtPrefix.Text=m.Get("prefix")                      
		txtEmail.Text=m.get("email")				
		txtEvalTeam.Text=m.Get("evalteam")
		strUnits=m.Get("units") 
		txtUnits.Text=strUnits
		If strUnits="mm" Then
			rbMM.Selected=True
			rbIn.Selected=False
		Else If strUnits="inches" Then
			rbMM.Selected=False
			rbIn.Selected=True
		Else
			rbMM.Selected=False
			rbIn.Selected=False
		End If
		 
		'Group the Unit rbos
		LUnits.Initialize	
			Dim n As Node
    For Each n As Node In PaneUnits.GetAllViewsRecursive 
        If n Is RadioButton Then LUnits.Add(n)
    Next
			rbMM.GroupRadioButtons(LUnits)
			rbIn.GroupRadioButtons(LUnits)           
		frmSetUp.show
	
End Sub

Sub btnUpdate_Action
	Dim mp As Map
	Dim wf As Map
	mp.Initialize:wf.initialize
	'update setup data			
				mp.Put("Organisation",txtOrganisation.text)
				mp.Put("Prefix",txtPrefix.text)
				mp.Put("Email",txtEmail.text)
				mp.Put("EvalTeam",txtEvalTeam.Text)
				mp.Put("Units",txtUnits.Text)				
				wf.Put("_id",1)
				DBUtils.UpdateRecord2(SQL1,"setup",mp, wf)
				Toast.ToastShow("Setup data saved.")
				Main.txtOrganisation.Text=txtOrganisation.Text
				Main.txtEvalTeam.Text=txtEvalTeam.text
				Main.txtEmail.text=txtEmail.Text
End Sub

Sub UnitsClick_SelectedChange(Checked As Boolean)
	Dim rbo As RadioButton
	If Checked=True Then
		rbo=Sender
		txtUnits.text=rbo.Tag
		strUnits=rbo.Tag
	End If
End Sub

Sub btnCancel_action
	frmSetUp.close
End Sub