﻿Type=StaticCode
Version=4
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Static code module
'Code module
'Subs in this code module will be accessible from all modules.
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules. 
	Private fx As JFX 
	Dim strDate, strSig,strSocial As  String 
	Dim  Cval As Int
	Dim Query As String
	Dim lstTable As List
	Dim val(5) As String
	Dim intLenTextDate As Int
	Dim intYearStart As Int
	Dim intYearEnd As Int
	Dim Msg As String
	Dim Invalid As Boolean
	Dim SQL1 As SQL

End Sub

Sub GetProvCount
	SQL1.InitializeSQLite(File.DirApp, "SCM.db3", True)
	Log(File.DirApp)
	Dim mp As Map
	mp.Initialize
	mp.Put("_id",Main.ObjID)
	Main.PCount = SQL1.ExecQuerySingleResult("SELECT count(*) FROM Prov WHERE ObjectID=" & Main.ObjID )
	'update the record
	DBUtils.UpdateRecord(SQL1,"Prov","provcount", Main.PCount, mp)
Log(Main.Pcount)
	Main.txtProvCount.text=Main.PCount
	Main.txtProvCount1.text=Main.PCount
	Main.txtCount.Text=Main.Pcount

	Return
End Sub

Sub UpdateRBOs(frm As String)
	Dim rb As RadioButton	
	If frm=1 Then
    For Each n As Node In Main.paneHist
        If n Is RadioButton Then 
			rb=n
			If (rb.Tag) = Main.His Then 	
			rb.Selected=True
			Else
			rb.selected=False
			End If
		End If
    Next
	For Each n As Node In Main.paneAes
        If n Is RadioButton Then 
			rb=n
			If (rb.Tag) = Main.Aes Then 	
			rb.Selected=True
			Else
			rb.selected=False
			End If
		End If
    Next
	For Each n As Node In Main.paneSci
        If n Is RadioButton Then 
			rb=n
			If (rb.Tag) = Main.Sci Then 	
			rb.Selected=True
			Else
			rb.selected=False
			End If
		End If
    Next
	For Each n As Node In Main.paneSoc
        If n Is RadioButton Then 
			rb=n
			If (rb.Tag) = Main.Soc Then 	
			rb.Selected=True
			Else
			rb.selected=False
			End If
		End If
    Next
	GetCval
	Else
    'frm=2..ObjectAdd
	For Each n As Node In ObjectAdd.paneHist
        If n Is RadioButton Then 
			rb=n
			If (rb.Tag) = Main.His Then 	
			rb.Selected=True
			Else
			rb.selected=False
			End If
		End If
    Next
	For Each n As Node In ObjectAdd.paneAes
        If n Is RadioButton Then 
			rb=n
			If (rb.Tag) = Main.Aes Then 	
			rb.Selected=True
			Else
			rb.selected=False
			End If
		End If
    Next
	For Each n As Node In ObjectAdd.paneSci
        If n Is RadioButton Then 
			rb=n
			If (rb.Tag) = Main.Sci Then 	
			rb.Selected=True
			Else
			rb.selected=False
			End If
		End If
    Next
	For Each n As Node In ObjectAdd.paneSoc
        If n Is RadioButton Then 
			rb=n
			If (rb.Tag) = Main.Soc Then 	
			rb.Selected=True
			Else
			rb.selected=False
			End If
		End If
    Next
	End If	
	
End Sub 

Sub GetCval
	Main.txtCultvalue.text =Main.Soc+Main.Sci+Main.Aes+Main.His
	Main.Cval=Main.txtCultValue.text

	Return
End Sub

Sub ConvertTicksToTimeString(t As Long) As String
    Dim  day, month, year, hours, minutes, seconds As Int
	day=DateTime.GetDayOfMonth(t)
	month = DateTime.GetMonth(t)
	year = DateTime.GetYear(t)
    hours =DateTime.GetHour(t)
	minutes=DateTime.Getminute(t)
	seconds=DateTime.GetSecond(t)
	
    Return day  &"/"& month &"/" & year &" " &hours&":"&minutes&":"&seconds
End Sub

Sub GetSig
'Header data
Dim datDate As Long
Dim strDate As String
datDate=DateTime.Now
strDate=ConvertTicksToTimeString(datDate)
strSig=Main.txtOrganisation.Text & "  OBJECT DETAILS REPORT"  & CRLF & CRLF & "Accession No:    " & Main.ObjAccn & CRLF &  "Object Name:    " &(Main.ObjName) &CRLF & "Accession Date:  " & Main.objAccnDate &CRLF & "Creation Team:   " & Main.txtEvalTeam.text
strSig=strSig& CRLF &"Description:        " & Main.ObjDesc & " (Set of " &Main.ObjSet &")"& CRLF &"Date Made:         " & Main.ObjDate
strSig=strSig& CRLF &"Classification:      " & Main.Primary&" - "&Main.Second&" - " &Main.objType
strSig=strSig& CRLF &"Materials:            " & Main.objMaterials &"    Dimensions (" & Main.Units &") W:" & Main.Objwidth &" H:"& Main.objHeight&" D" & Main.objDepth
strSig=strSig& CRLF &"Condition:           " & Main.objCond &"                          Conservation Date: " & Main.objConsDate & CRLF&"Conservator:       " & Main.objCons
strSig=strSig& CRLF &"Storage:              " & Main.objStorage&CRLF &"Loan Details:      " & Main.objLoan &CRLF &"Export:               " & Main.objExport

strSig=strSig& CRLF &"STATEMENT OF SIGNIFICANCE  "&CRLF
If Main.Aes <2 Then
  strSig=strSig & "The object '" & Main.ObjName & "' (" & Main.ObjAccn & ") has little aesthetic significance."
Else If Main.Aes= 2 Then
     strSig=strSig &  "The object '" & Main.ObjName & "' (" & Main.ObjAccn & ") has some aesthetic significance, given its  (form, colour texture)."
Else If Main.Aes=3 Then
      strSig=strSig &  "The object '" & Main.ObjName & "' (" & Main.ObjAccn & ") has high aesthetic significance, given its  (form, colour texture)."
Else
       strSig=strSig & "The object '" & Main.ObjName & "' (" & Main.ObjAccn & ") has very high aesthetic significance, given its  (form, colour texture)."
End If

If Main.Sci < 2 Then
        strSig = strSig & " The item has low scientific significance, although being representative of the class " & Main.Primary & "/" & Main.Second & " ."
Else If Main.Sci=2 Then
        strSig = strSig & " The item has some scientific significance, being an example in " & Main.ObjCond.ToLowerCase & " condition of the class " & Main.Primary & "/" & Main.Second &  " ."
Else If Main.Sci=3 Then
        strSig = strSig & " The item has scientific significance, being an excellent example in " & Main.ObjCond.ToLowerCase & " condition of the class " & Main.Primary & "/" & Main.Second &  " ."
Else If Main.Sci=4 Then
        strSig = strSig & " The item has high scientific significance, being a rare example in " & Main.ObjCond.ToLowerCase & " condition of the class " & Main.Primary & "/" & Main.Second &    " ."
Else If Main.Sci=5 Then
        strSig = strSig & " The item has high scientific significance, being a very rare example in " & Main.ObjCond.ToLowerCase & " condition of the class " & Main.Primary & "/" & Main.Second & " ."
End If
If Main.PCount =0 Then
        strSig = strSig & " The item is unprovenanced."
    
Else 
	If Main.PCount=0 And Main.Soc >0 Then
			strSocial = "...  << 'Social' value but no links.... >>"
	Else
				If Main.Soc =1 Then
				    strSocial = " This object has little social significance, but was  "
				 Else If Main.Soc = 2 Then
				    strSocial = " This object has some social significance which adds to its interpretive potential being  "
				 Else If Main.Soc = 3 Then
				    strSocial = " This object has well documented social significance which adds to its interpretive potential given it was "
				 Else
				    strSocial = " This object has very high social significance which adds to its interpretive potential given it was "
				End If		
'collect provenance data
Dim RowID As Int      
Dim row As Int
Dim RS As ResultSet = SQL1.ExecQuery("SELECT _id FROM Prov WHERE ObjectID=" & Main.ObjID &";") 
Do While RS.NextRow
	RowID=(RS.GetString("_id"))

		Query="SELECT *  From Prov WHERE _id=" & RowID &";"
		lstTable=DBUtils.ExecuteMemoryTable(SQL1,Query,Null,0)
			val = lstTable.Get(row)
			strSocial=strSocial & " " & val(5) & " "& val(1) & " (" & val(6)& "), "
		Loop
		'remove the last comma
		strSocial=Mid(strSocial, 1, strSocial.Length-2)
		strSocial=strSocial &  "." 
		strSig=strSig & strSocial
RS.Close		
		
	End If
End If

'add recommendation
Dim Ctext As String
Dim ConsText As String
Cval=Main.His+Main.Sci+Main.Soc+Main.Aes
		If Cval < 6 And Main.PCount<>0 Then
            Ctext = CRLF & "(Having documented provenance, the recommended minimum Cultural Value is 6.)"
        End If
		
'conservation		
If Main.objConsDate.Length >1 And Main.objConsDate.Length <5 Then
	ConsText=ConsText&"The object was conserved in " & Main.objConsDate
	else If Main.objConsDate.Length > 4 Then
		ConsText=ConsText&"The object was conserved on " & Main.objConsDate
End If

If Main.Cons.length>1  Then
	ConsText=ConsText & " by  conservation practitioner " & Main.Cons & "."

End If
If (Main.objConsDate.Length<2 And Main.cons.length<2) Then
	If Cval>13 Then
	ConsText=ConsText &"It is recommended that an expert conservation practitioner be consulted to draw up a conservation plan for this object and that all necessary steps be taken to conserve it."
	Else If Cval>10 Then
	ConsText=ConsText &"It is recommended that all necessary steps be taken to conserve it."
	Else If Cval>7 Then
	ConsText=ConsText &"It is recommended that, when possible, steps be taken to conserve it."
	Else If Cval>3 Then
	ConsText=ConsText &"It is recommended that conservation be carried out on an 'as needs' basis."
	End If
End If


If Cval > 17 Then
            strSig = strSig & CRLF & "RECOMMENDATION (Category 1)" & CRLF & "This object has very high, possibly national cultural significance. " & ConsText
Else If Cval > 13 Then
            strSig = strSig & CRLF & "RECOMMENDATION (Category 2)" & CRLF & "This object has very high, possibly statewide cultural significance. "& ConsText
Else If Cval >10 Then
            strSig = strSig & CRLF & "RECOMMENDATION (Category 3)" & CRLF & "This object has very high cultural significance for the local community. "& ConsText
Else If Cval >7 Then
            strSig = strSig & CRLF & "RECOMMENDATION (Category 4) " & Ctext & CRLF & "This object has high cultural significance. "& ConsText
Else If Cval >3 Then
            strSig = strSig & CRLF & "RECOMMENDATION (Category 5) " & Ctext & CRLF & "This object has some cultural significance based on interpretive potential. "& ConsText
Else
            strSig = strSig & CRLF & "RECOMMENDATION (Category 6) " & Ctext & CRLF & "This object has low cultural significance, deacccesioning should be considered if there is limited interpretation potential and poor condition. "
End If
strSig=strSig &CRLF&CRLF & "Report Created: "& strDate

Return(strSig)
End Sub

Sub Mid(Text As String, Start As Int, Length As Int) As String   
Return Text.SubString2(Start-1,Start+Length-1)
End Sub

Sub ParseTextDate(strInTextDate As String)
'---------------------------------------------------------------------------------
'This function parses various text dates as used by historians and returns
'two numeric years suitable for searching a year range....
'Acceptable inputs are:  yyyy ;   cyyyy ;    yyy0s ; [eg 1890s]
'                       cyyy0s; [eg c150s] ; dd/mm/yyyy; mm/yyyy;
'                       yyyy,yyyy; yyyy,yyyy,yyyy.
'This function is free to any user
'provided the author is acknowledged as follows:
'Author: Graham Grundy,
'        PO Box 34 DONGARA WA Australia
'        oldeast@midwest.com.au, March 1998
'------------------------------------------------------------------------------------

'
'Test for text in TextDate
If strInTextDate="" Then Return


'Get length of the TextDate
intLenTextDate = strInTextDate.Length
'Process according to length....
Select intLenTextDate
                            'Must be N/A
Case 3
If strInTextDate = "N/A" Then
Return
Else:Invalid=True 
End If

Case  4                  ' must be four digit year, YearMinus and YearPlus = 0
intYearStart = Mid(strInTextDate, 1, 4)
intYearEnd = intYearStart
Case 5                 ' either cYYYY or yyy0s
If Mid(strInTextDate, 1,1) = "c" Then
	
	intYearStart = Mid(strInTextDate, 2, 4) -5
	intYearEnd = intYearStart + 10

Else If Mid(strInTextDate, 4, 2) = "0s" Then
	
	intYearStart = Mid(strInTextDate, 1, 4) 
	intYearEnd = intYearStart+9	
Else
	Invalid=True
End If
Case 6                  'must be cyyy0s
If Mid(strInTextDate,1,1) = "c" And Mid(strInTextDate, 5, 2) = "0s" Then
	
	intYearStart = Mid(strInTextDate, 2, 4)-5
	intYearEnd = intYearStart+20

Else
	Invalid=True
End If
Case  7                  'must be mm/yyyy or Unknown
If Mid(strInTextDate, 3, 1) = "/" Then
	intYearStart = Mid(strInTextDate, 4, 4)
	intYearEnd = intYearStart
Else If strInTextDate = "Unknown" Then
	Return
Else
	Invalid=True
End If
Case 9                  'must be yyyy,yyyy
If Mid(strInTextDate, 5, 1) = "," Then
	intYearStart = Mid(strInTextDate, 1,4)
	intYearEnd = Mid(strInTextDate, 6, 4)

Else
	Invalid=True
End If
Case 10                 'must be mm/dd/yyyy
If Mid(strInTextDate, 3, 1) = "/" And Mid(strInTextDate, 6, 1) = "/" Then
	intYearStart = Mid(strInTextDate, 7, 4)
	intYearEnd = intYearStart

Else
	Invalid=True
End If
Case 14                  'must be yyyy,yyyy,yyyy
If Mid(strInTextDate, 5, 1) = "," And Mid(strInTextDate, 10, 1) = "," Then
	intYearStart = Mid(strInTextDate,1, 4)
	intYearEnd = Mid(strInTextDate, 11, 4)

Else
	Invalid=True
End If
Case Else
	Invalid=True
	intYearStart = 0
	intYearEnd = 0
End Select




'Validates the four digits of the year in TextDate is a valid nunber
'intintYearstart = CInt(varintYearstart)
'intintYearEnd = CInt(varintYearEnd)


'Check that last year entered is greater than the first
If intYearStart > intYearEnd Then
	Msg = "The final year you entered is less than the first," _
	&CRLF & "                       please reenter the years .."
	Dim res As Int = fx.Msgbox2(ObjectAdd.frmObjAdd, Msg,"Invalid Entry","OK", "", "", fx.MSGBOX_WARNING)
	intYearStart = 0
	intYearEnd = 0
	If res = fx.DialogResponse.POSITIVE Then Return


End If
End Sub