﻿Type=StaticCode
Version=4
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Static code module


Sub Process_Globals
	Private fx As JFX
	Private poi As PoiWorkbook
	
	Private sheet As PoiSheet
	Private HdrList As List
	Dim rows As Int
	Dim frmExport As Form
	Dim strQuery As String
	Dim n As String
	Dim p As String
	Dim SQL1 As SQL
	Dim Export As Form
	
	Private btnBrowse As Button
	Private btnCancel As Button
	Private btnExport1 As Button
	Private lblFile, lblMessage, lblFilePath,lblTitle As Label
	Private txtFile As TextField
	Private txtFilePath As TextField
	Private Toast As ToastMessageShow
End Sub

Sub AddData
			
			If  	Export.IsInitialized=False Then
					Export.Initialize("frmExport", 530, 300)
					Export.SetFormStyle("UNIFIED")
					Export.RootPane.LoadLayout("Export")
					
					Toast.ToastNotificationOwner = frmExport
					Toast.Initialize("Toast")
					Toast.ToastIconSize32x32
					Toast.ToastDuration = 6 'Toast.TOAST_LONG_DELAY
					Toast.ToastTextLocation = Toast.TEXT_CENTER
					Toast.ToastLocation= Toast.TOAST_CENTER_RIGHT
					Toast.ToastMessageColor = fx.Colors.Green
					
					SQL1.InitializeSQLite(File.DirApp, "SCM.db3",False)
			End If

Export.show
End Sub
Sub btnBrowse_action
	OpenWorkbook
End Sub


Sub OpenWorkbook
	
	Dim fc As FileChooser                 ' Use filechooser from jFX library
	Dim fileSelected As JavaObject            ' File selected. If selected full path is returned else ""
	fc.Initialize                         ' Init! Do not forget
	fc.InitialDirectory = File.DirApp     ' Set starting folder
	fc.Title = "Select a File"
	fc.SetExtensionFilter("Excel files..",Array As String("*.xls","*.xlsx"))

  
   fileSelected = fc.ShowOpen(frmExport) ' Show the dialog and select
   Log("File selected: " & fileSelected)
   'Return fileSelected
   Dim fileO As JavaObject
	fileO.InitializeNewInstance("java.io.File", Array As Object(fileSelected))

  n = fileO.RunMethod("getName",Null)
  p = fileO.RunMethod("getPath", Null)
 p = p.Replace(n, "")
 Log(p):Log(n)
 	
poi.InitializeExisting(p,n,"")
  sheet=poi.GetSheet(0)
  txtFile.Text=n
  txtFilePath.Text=p
HdrList.Initialize
	HdrList.AddAll(Array As String("accession" , "name" , "objectset" , "description" ,"datemade" , "primaryclass" , "secondclass" , "objecttype" , "materials" , "condition" , "width" , "height" , "depth" , "consdate" , "conservator" , "condnotes" , "history" , "storage" , "loan" , "accby" , "accdate" , "culturalvalue","aesthetic","historic","scientific","social","sig","export"))
	
	poi.InitializeExisting(p,n,"")
    sheet=poi.GetSheet(0)
Dim NewRow As PoiRow = sheet.CreateRow(0) 'title row
	
   'print the headers 
For i = 0 To HdrList.Size - 1
	NewRow.CreateCellString(i,HdrList.Get(i))
	'Log(NewRow.CreateCellString(i,HdrList.Get(i)))
Next
'start export 
rows= SQL1.ExecQuerySingleResult("SELECT count(*) FROM Objects Where Export='Yes'")

	'make a list of the record Ids
	Dim lst As List
	lst.initialize
	Dim m As Map
	m.initialize
	strQuery= "Select _id from Objects Where Export='Yes'"
	DBUtils.ExecuteList(SQL1,strQuery,Null,0,lst)
	For i=0 To lst.Size-1
	strQuery="Select * From Objects where _id=" & lst.Get(i)
	m=DBUtils.ExecuteMap(SQL1,strQuery,Null)
	Dim DataRow As PoiRow = sheet.CreateRow(i+1)
	Dim strColumn As String
		For j=0 To 27
			strColumn=HdrList.Get(j)
		DataRow.CreateCellString(j,m.Get(strColumn))	
		Next
	Next
	poi.Save(p,n)
poi.close
Toast.ToastShow("Export completed.")
End Sub
Sub btnCancel_Action
	txtFile.Text=""
	txtFilePath.Text=""
	Export.close
	
End Sub

