﻿Type=StaticCode
Version=4
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Static code module



Sub Process_Globals
	Private fx As JFX
	Private poi As PoiWorkbook
	Private cell() As PoiCell
	Private row() As PoiRow
	Private sheet As PoiSheet
	Private HdrList As List
	Private XLList As List
	Dim rows As Int
	Dim frmImport As Form
	Dim strQuery As String
	Dim SQL1 As SQL
	Dim Import As Form
	
	Private btnBrowse As Button
	Private btnCancel As Button
	Private btnImport1 As Button
	Private lblFile As Label
	Private lblFileDetails As Label
	Private lblFilePath As Label
	Private lblTitle As Label
	Private txtFile As TextField
	Private txtFilePath As TextField
End Sub

Sub AddData
			
			If  	Import.IsInitialized=False Then
					Import.Initialize("frmImport", 530, 400)
					Import.SetFormStyle("UNIFIED")
					Import.RootPane.LoadLayout("Import")
			
					SQL1.InitializeSQLite(File.DirApp, "SCM.db3",False)
			
			End If

Import.show
End Sub
Sub btnBrowse_action
	OpenWorkbook
End Sub
Sub OpenWorkbook
	HdrList.Initialize
	HdrList.AddAll(Array As String("Accn" , "Name" , "Set" , "Description" ,"DateMade" , "Primary" , "Secondary" , "Tertiary" , "Materials" , "Condition" , "Width" , "Height" , "Depth" , "ConsDate" , "Conservator" , "CondNotes" , "History" , "Storage" , "Loan" , "EnteredBy" , "AccnDate" , "Export"))
	
	Dim fc As FileChooser                 ' Use filechooser from jFX library
	Dim fileSelected As JavaObject            ' File selected. If selected full path is returned else ""
	fc.Initialize                         ' Init! Do not forget
	fc.InitialDirectory = File.DirApp     ' Set starting folder
	fc.Title = "Select a File"
	fc.SetExtensionFilter("Excel files..",Array As String("*.xls","*.xlsx"))

  
   fileSelected = fc.ShowOpen(frmImport) ' Show the dialog and select
   Log("File selected: " & fileSelected)
   'Return fileSelected
   Dim fileO As JavaObject
	fileO.InitializeNewInstance("java.io.File", Array As Object(fileSelected))

  Dim n As String = fileO.RunMethod("getName",Null)
  Dim p As String = fileO.RunMethod("getPath", Null)
 p = p.Replace(n, "")
 Log(p):Log(n)
 
  poi.InitializeExisting(p,n,"")
  sheet=poi.GetSheet(0)
  

 Dim lst1 As List
 lst1.Initialize
 lst1.AddAll(sheet.GetRow(0).Cells)
 
For i = 0 To lst1.Size - 1
 Dim pc As PoiCell = lst1.Get(i)
 Dim s As String = HdrList.Get(i)
 If pc.Value <> s Then
  Dim x As Int=i+1
  Log("Column " & x &" header name is " & pc.Value & " but should be " & s)
 fx.Msgbox2(Null, "Column " & x &" header name is " & pc.Value & " but should be " & s &"Please correct the File and try again.","Column Name Error" ,"OK","","",fx.MSGBOX_WARNING)
Import.Close
Return
End If
Next
'get the number of rows
 x=sheet.LastRowNumber
  rows=x
  Log( x):Log(p):Log(n)
  txtFilePath.Text=p:txtFile.text=n
 fx.Msgbox(Null,"Column headers are correct." & CRLF & "There are " & rows & " rows ready for import","File Ready" )
End Sub
 Sub btnImport1_action
 Dim pc As PoiCell
 Dim XLList As List
 XLList.initialize
 Dim lst As List
 Dim strObjDate As String
 lst.Initialize
 Dim mp As Map
 mp.Initialize
 
 'get only data rows, avoid header roww
 For i=1 To rows
 	Log(i)
 	For j = 0 To 21 '20 columns
		If sheet.GetRow(i).GetCell(j).IsInitialized=True Then
		 pc=(sheet.GetRow(i).GetCell(j))
			'convert all data to string
			pc.CellType=1
			XLList.add(pc)
		 Else
		 	XLList.Add("")
			End If
	Next
		'add a record
		Log(XLList)
				mp.Put("_id",Null)	
				mp.Put("accession",XLList.Get(0))
				mp.Put("name",XLList.Get(1))
				mp.Put("objectset",XLList.Get(2))
				mp.Put("description",XLList.Get(3))
				mp.Put("datemade",XLList.Get(4))
				mp.Put("primaryclass",XLList.Get(5))
				mp.Put("secondclass",XLList.Get(6))
				mp.Put("objecttype",XLList.Get(7))
				mp.Put("materials",XLList.Get(8))
				mp.Put("condition",XLList.Get(9))
				mp.Put("width",XLList.Get(10))
				mp.Put("height",XLList.Get(11))
				mp.Put("depth",XLList.Get(12))
				mp.Put("consdate",XLList.Get(13))
				mp.Put("conservator",XLList.Get(14))
				mp.Put("condnote",XLList.Get(15))
				mp.Put("history",XLList.Get(16))
				mp.Put("storage",XLList.Get(17))
				mp.Put("loan",XLList.Get(18))
				mp.Put("accby",XLList.Get(19))
				'convert date to string
				strObjDate=(XLList.Get(20))
				mp.Put("accdate",strObjDate):strObjDate=""
				mp.Put("export",XLList.Get(21))
				'check if the date can make a date range
				strObjDate=XLList.Get(4)
				Utils.ParseTextDate(strObjDate)
				mp.Put("yearstart", Utils.intYearStart)
				mp.Put("yearend", Utils.intYearEnd)
				mp.Put("historic","0")
				mp.Put("aesthetic","0")
				mp.Put("scientific","0")
				mp.Put("social","0")
				mp.Put("culturalvalue","0")
				mp.Put("provcount","0")
				mp.Put("sig",Null)
				lst.Add(mp)
				DBUtils.Insertmaps(SQL1,"Objects",lst)
				mp.clear
				XLList.clear
				lst.clear
Next
	fx.Msgbox(Null,rows & " records have been added.","Import Completed")
	strQuery = "SELECT _id[ID],  Accession[Accn No.], Name[Object Name] FROM Objects Order BY Name;"
		DBUtils.ExecuteTableview(SQL1,strQuery,Null,0,Main.tblObjEdit)
		Main.tblObjEdit.SetcolumnVisible(0,False)
		Main.tblObjEdit.SetColumnWidth(1,80)
		Main.tblObjEdit.SetColumnWidth(2,200)
		strQuery="Select _id from Objects Order By _id DESC"
		'update the object ID
		Dim m As Map
		m = DBUtils.ExecuteMap(SQL1, strQuery, Null)
		Main.ObjID=m.Get("_id")
End Sub
Sub btnCancel_Action
	txtFile.Text=""
	txtFilePath.Text=""
	Import.close
	
End Sub