﻿Type=StaticCode
Version=4
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@

'Static code module
Sub Process_Globals
	Private fx As JFX
	Private Aes1,Aes2,Aes3,Aes4,Aes5 As RadioButton
	Private btnCancel,btnSave, btnClassn, btnDateMade As Button
	Private Hist1, Hist2,Hist3,Hist4,Hist5 As RadioButton
	Private lblAesthetic,lblCondition,lblCons,lblConsDate,lblCultValue,lblDateMade As Label
	Private lblDetails1,lblHistoric,lblName, lblUnits As Label
	Private lblPrimaryClass,lblScientific,lblSecondClass,lblSocial, lblValues, lblProvCount, lblMaterials As Label
	Private Pane1, Pane2 As Pane
	Public paneAes,paneHist,paneSci,paneSoc As Pane
	Private Sci1,Sci2,Sci3,Sci4,Sci5 As RadioButton
	Private Soc1,Soc2,Soc3,Soc4,Soc5 As RadioButton
	Private txtAccn,txtAccnYear,txtAccnCode,txtAccnNo,txtCons,txtConsDate As TextField
	Private txtDateMade,txtName As TextField
	Private txtWidth,txtDepth,txtHeight,txtSet,txtYearStart,txtYearEnd As TextField
	Private txtAccnBy,txtAccnDate, txtLoan, txtMaterials As TextField
	Private txtDescription, txtConditionNote, txtHistory As TextArea
	Public txtCultValue,txtDateMade,txtHist,txtName,txtSig As TextField
	Public txtPrimaryClass,txtAes,txtSci,txtSecondClass,txtSoc,txtProvCount As TextField
	
	Public cboCondition,cboStorage,cboObjectType, cboExport As ComboBox
	
	Public  Result As Boolean
	Private Toast As ToastMessageShow
	Public frmObjAdd As Form
	Dim LHis,LAes,LSci,LSoc As List
	Dim strQuery, Msg As String
	Dim SQL1 As SQL
	Dim frmObjAdd As Form

End Sub


Public Sub EditAddObject
			
			If  frmObjAdd.IsInitialized = False Then
					frmObjAdd.Initialize("ObjectAdd", 1200, 650)
					frmObjAdd.SetFormStyle("UNIFIED")
					frmObjAdd.RootPane.LoadLayout("ObjectAdd")
					SQL1.InitializeSQLite(File.DirApp, "SCM.db3",False)
					
					Toast.Initialize("Toast")
					Toast.ToastIconSize32x32
					Toast.ToastDuration = 6 'Toast.TOAST_LONG_DELAY
					Toast.ToastTextLocation = Toast.TEXT_CENTER
					Toast.ToastLocation= Toast.TOAST_CENTER_RIGHT
					Toast.ToastMessageColor = fx.Colors.Green
			
			'fill combo boxes		
					cboCondition.Items.Add("Fair")
					cboCondition.Items.Add("Good")
					cboCondition.Items.Add("Poor")
					cboCondition.Items.Add("Unknown")
					cboCondition.Items.Add("Very Good")
					
					cboExport.Items.Add("Yes")
					cboExport.Items.Add("No")
			'storage		
					DBUtils.ExecuteList(SQL1, "SELECT storageplace FROM storage order by storageplace", Null, 0, cboStorage.Items)	
			'Tertiary
					DBUtils.ExecuteList(SQL1, "SELECT tertiaryclass FROM Tertiary order by tertiaryclass", Null, 0, cboObjectType.Items)	
		End If
	Select Main.Action
		Case 2
			'*************NEW RECORD
			lblDetails1.Text=" ADD NEW OBJECT" 
			txtAes.Text=0: txtHist.Text=0:txtSci.text=0:txtSoc.Text=0		
			txtCultValue.Text=0
			cboExport.Value="Yes"	

			rboList
			frmObjAdd.show
		
		Case 1
		
			'****************EDIT current Record
			
					lblDetails1.Text=" EDIT OBJECT:" & Main.ObjName 
					'Display data and store for Significance
					
					txtAccn.Text= Main.ObjAccn
					txtAccnBy.Text=Main.objAccnBy
					txtAccnCode.Text=Main.objAccnCode
					txtAccnDate.Text=Main.objAccnDate
					txtAccnNo.Text=Main.ObjAccnNo
					txtAccnYear.Text=Main.ObjAccnYear
					txtSet.Text=Main.ObjSet
					cboCondition.Value= Main.ObjCond
					txtConditionNote.Text=Main.ObjCondNote
					txtConsDate.Text=Main.objConsDate            
					txtCons.Text=Main.objCons
					txtDateMade.Text=Main.ObjDate
					txtYearStart.Text=Main.objYearStart
					txtYearEnd.Text=Main.objYearEnd
					txtDescription.Text=Main.objDesc
					txtMaterials.Text=Main.objMaterials
					txtHeight.Text=Main.objHeight
					txtWidth.Text=Main.objwidth
					txtDepth.Text=Main.objDepth
					txtHistory.Text=Main.objHist
					cboExport.Value=Main.ObjExport
					cboStorage.Value=Main.objStorage
					cboObjectType.Value=Main.objType
					txtName.Text =Main.ObjName 
					txtLoan.Text=Main.objLoan
					lblUnits.Text=Main.units                            
					'load the Primary and Secondary Classification data..
					txtPrimaryClass.Text=Main.Primary	
					txtSecondClass.Text=Main.Second 
					
					'load the criteria settings              
					txtHist.Text=Main.His				    
					txtAes.Text=Main.Aes			
					txtSoc.text=Main.Soc
					txtSci.text=Main.Sci
					txtCultValue.Text=Main.Cval
					txtProvCount.Text=Main.PCount
					
											
					'update the crieria radio buttons
			'		'++++reset the radio buttons to stored value
					
					rboList
					Utils.UpdateRBOs(2)
					frmObjAdd.show					 
End Select
End Sub
'create accn number
Sub txtAccn_TextChanged(Old As String, New As String)
	txtAccn.text=txtAccnYear.Text&"."& txtAccnCode.Text&"."& txtAccnNo.text
End Sub
'create date range
Sub btnDatemade_Action
If txtDateMade.text="" Then Return

	Utils.ParseTextDate(txtDateMade.Text)

If Utils.Invalid=True Then
Msg = "The text you have entered cannot be processed." & CRLF _
& "To make a valid date range for searches," & CRLF _
& "match your entry to one of the following..." & CRLF & CRLF _
& "dd/mm/yyyy     eg 01/05/1902" & CRLF & "mm/yyyy           eg 04/1932" & CRLF & "yyyy                  eg 1856" & CRLF & "cyyyy                eg c1893" _
& CRLF & "cyyy0s              eg c1870s" & CRLF & "yyyy,yyyy           eg 1911,1942" & CRLF & "yyyy,yyyy,yyyy   eg 1911,1942,1976" _
& CRLF & "Valid years are from 1200 to current year." & CRLF & "You may also use 'Unknown' and 'N/A' "

fx.Msgbox2(Null, Msg,"Invalid Entry","OK", "", "", fx.MSGBOX_WARNING)
txtYearStart.Text=""
	txtYearEnd.Text=""
	Utils.Invalid=False
Else
	txtYearStart.Text=Utils.intYearStart
	txtYearEnd.Text=Utils.intYearEnd
	End If
End Sub
'save record
Sub btnSave_Action	
	If txtAccn.Text="" Then
	 fx.Msgbox2(Null, "An Accession Number is required for " & txtName.text,"Please Update","OK", "", "", fx.MSGBOX_WARNING)
	 Return
	End If
	'add Accession date and time if required..
	If txtAccnDate.Text="" Then
		Dim datDate As Long
		Dim strDate As String
		datDate=DateTime.Now
		strDate=Utils.ConvertTicksToTimeString(datDate)
		txtAccnDate.Text=strDate
	End If
		
	Dim mp As Map
		mp.Initialize
		mp.Clear
	Dim wf As Map
		wf.Initialize
		'editing a record
				If Main.Action=1 Then
				wf.Put("_id",Main.ObjID)
				Else
		'add a record
				mp.Put("_id",Null)
				End If
			
				mp.Put("loan",txtLoan.Text)
				mp.Put("name",txtName.Text)
				mp.Put("accession",txtAccnYear.Text&"." & txtAccnCode.Text & "." & txtAccnNo.Text)
				mp.Put("accyear", txtAccnYear.Text)
				mp.Put("acctext", txtAccnCode.Text)
				mp.Put("accnum", txtAccnNo.Text)
				mp.Put("objectset", txtSet.Text)
				mp.Put("accdate", txtAccnDate.Text)
				mp.Put("objecttype", cboObjectType.Value)
				mp.Put("export", cboExport.Value)
				mp.Put("description",txtDescription.Text)
				mp.Put("primaryclass",txtPrimaryClass.Text)
				mp.Put("secondclass",txtSecondClass.Text)
				mp.Put("datemade",txtDateMade.Text)
				mp.Put("yearstart",txtYearStart.Text)
				mp.Put("yearend",txtYearEnd.Text)
				mp.Put("condition",cboCondition.Value)
				mp.Put("materials",txtMaterials.Text)
				mp.Put("width",txtWidth.Text)
				mp.Put("height",txtHeight.Text)
				mp.Put("depth",txtDepth.Text)
				mp.Put("consdate",txtConsDate.Text)
				mp.Put("condnote",txtConditionNote.Text)
				mp.Put("storage",cboStorage.Value)
				mp.Put("conservator",txtCons.Text)
				mp.Put("historic",txtHist.Text)
				mp.Put("aesthetic",txtAes.Text)
				mp.Put("scientific",txtSci.Text)
				mp.Put("social",txtSoc.Text)
				mp.Put("history",txtHistory.Text)
				mp.Put("loan",txtLoan.Text)
				mp.Put("culturalValue",txtCultValue.Text)
				mp.Put("sig","")
				
						If txtAccnBy.Text="" Then
						strQuery="Select EvalTeam from Setup"
						Dim m As Map
						m = DBUtils.ExecuteMap(SQL1, strQuery, Null)
						txtAccnBy.Text=m.Get("evalteam")
						End If
				mp.Put("accby", txtAccnBy.Text)
				
				Main.ObjAccn=txtAccn.Text
				Main.objAccnBy=txtAccnBy.Text
				Main.ObjAccnCode=txtAccnCode.Text
				Main.objAccnDate=txtAccnDate.Text
				Main.ObjAccnYear=txtAccnYear.Text
				Main.ObjAccnNo=txtAccnNo.Text
				Main.ObjAccn=txtAccnYear.text&"."&txtAccnCode.Text&"."&txtAccnNo.text
				Main.ObjCond=cboCondition.value
				Main.objConsDate=txtConsDate.text
				Main.objCons=txtCons.text
				Main.ObjCondNote=txtConditionNote.Text
				Main.ObjDate=txtDateMade.Text
				Main.objYearStart=txtYearStart.Text
				Main.objYearEnd=txtYearStart.Text
				Main.objDepth=txtDepth.Text
				Main.ObjDesc=txtDescription.Text
				Main.objMaterials=txtMaterials.Text
				Main.objExport=cboExport.Value
				Main.objStorage=cboStorage.Value
				Main.objType=cboObjectType.Value
				Main.objHeight=txtHeight.Text
				Main.ObjHist=txtHistory.Text
				Main.objLoan=txtLoan.Text
				Main.objName=txtName.Text
				Main.ObjSet=txtSet.Text
				Main.objWidth=txtWidth.Text
				'load the criteria settings              
				Main.His=txtHist.Text			    
				Main.Aes=txtAes.Text		
				Main.Soc=txtSoc.text
				Main.Sci=txtSci.text
				Main.Cval=txtCultValue.Text
			
				txtCultValue.Text=txtAes.Text+txtHist.Text+txtSci.Text+txtSoc.text
				Main.Cval=txtCultValue.text
				'Main.PCount=txtProvCount.text
				txtAccn.Text= Main.ObjAccn
					                         
		'load the Primary and Secondary Classification data..
		Main.Primary=txtPrimaryClass.Text	
		Main.Second=txtSecondClass.Text
		
		'store values for significance generator
		'update the values on the Object form
		Utils.UpdateRBOs(1)
		
		
		If Main.Action=1 Then			
		DBUtils.UpdateRecord2(SQL1, "Objects", mp,wf)
		Toast.ToastMessageColor = fx.Colors.Yellow
		Toast.ToastShow("Record " & txtName.Text &" has been updated.")
		Else
			
		'Save new record
		Dim lst As List
		lst.Initialize
		lst.Add(mp)
		DBUtils.Insertmaps(SQL1,"Objects",lst)
		Toast.ToastMessageColor = fx.Colors.Green
		Toast.ToastShow("Record " & txtName.Text &" has been saved.")
		strQuery = "SELECT _id[ID],  Accession[Accn No.], Name[Object Name] FROM Objects Order BY Name;"
		DBUtils.ExecuteTableview(SQL1,strQuery,Null,0,Main.tblObjEdit)
		Main.tblObjEdit.SetcolumnVisible(0,False)
		Main.tblObjEdit.SetColumnWidth(1,80)
		Main.tblObjEdit.SetColumnWidth(2,200)
		strQuery="Select _id from Objects Order By _id DESC"
		'update the object ID
		Dim m As Map
		m = DBUtils.ExecuteMap(SQL1, strQuery, Null)
		Main.ObjID=m.Get("_id")
		'set the Prov and sig tabs
		'SignForm.txtSig.Text=""
		
		'update the prov
		Dim m As Map
		strQuery="SELECT * FROM Prov where _id =0"
			m = DBUtils.ExecuteMap(SQL1, strQuery, Null)	
			'Main.btnProvDelete.Text="Select Record..."
		End If
		frmObjAdd.BackColor=fx.Colors.Green
		Main.SynchroniseObject
		frmObjAdd.close
		
End Sub	
'update after transfer
Sub TransferUpdate
	strQuery="Select _id, storage from Objects where _id="& Main.objID
Dim m As Map
	m.Initialize
	m = DBUtils.ExecuteMap(SQL1, strQuery, Null)
	cboStorage.Value=m.Get("storage")
End Sub
'add storage or object type
Sub btnTypeStor_action
	Dim btn As Button
	btn=Sender
	AddTypeStor.Action=btn.tag
	AddTypeStor.TypeStorLoad

End Sub

'rboList groups RBOs				
Sub rboList
			LHis.Initialize:LAes.Initialize:LSci.Initialize:LSoc.Initialize	
			Dim n As Node
    For Each n As Node In paneHist.GetAllViewsRecursive 
        If n Is RadioButton Then LHis.Add(n)
    Next
			Hist1.GroupRadioButtons(LHis)
			Hist2.GroupRadioButtons(LHis)
			Hist3.GroupRadioButtons(LHis)
			Hist4.GroupRadioButtons(LHis)
			Hist5.GroupRadioButtons(LHis)
	For Each n As Node In paneAes.GetAllViewsRecursive 
        If n Is RadioButton Then LAes.Add(n)
    Next
			Aes1.GroupRadioButtons(LAes)
			Aes2.GroupRadioButtons(LAes)
			Aes3.GroupRadioButtons(LAes)
			Aes4.GroupRadioButtons(LAes)
			Aes5.GroupRadioButtons(LAes)
			
	For Each n As Node In paneSci.GetAllViewsRecursive 
        If n Is RadioButton Then LSci.Add(n)
    Next
			Sci1.GroupRadioButtons(LSci)
			Sci2.GroupRadioButtons(LSci)
			Sci3.GroupRadioButtons(LSci)
			Sci4.GroupRadioButtons(LSci)
			Sci5.GroupRadioButtons(LSci)
			
			For Each n As Node In paneSoc.GetAllViewsRecursive 
        If n Is RadioButton Then LSoc.Add(n)
    Next
			Soc1.GroupRadioButtons(LSoc)
			Soc2.GroupRadioButtons(LSoc)
			Soc3.GroupRadioButtons(LSoc)
			Soc4.GroupRadioButtons(LSoc)
			Soc5.GroupRadioButtons(LSoc)		
						
End Sub

Sub HistClick_SelectedChange(Checked As Boolean)
	Dim rbo As RadioButton
	Log(txtHist.Text)
	If Checked=True Then
		rbo=Sender
		txtHist.text=rbo.Tag
		Main.His=txtHist.text
		Utils.GetCval
		txtCultValue.Text=Main.Cval
	End If
	
End Sub

Sub AesClick_SelectedChange(Checked As Boolean)
	Dim rbo As RadioButton
	If Checked=True Then
		rbo=Sender
		txtAes.text=rbo.Tag
		Main.Aes=txtAes.text
		Utils.GetCval
		txtCultValue.Text=Main.Cval
	End If
End Sub

Sub SciClick_SelectedChange(Checked As Boolean)
	Dim rbo As RadioButton
	If Checked=True Then
		rbo=Sender
		txtSci.text=rbo.Tag
		Main.Sci=txtSci.text
		Utils.GetCval
		txtCultValue.Text=Main.Cval
	End If
End Sub

Sub SocClick_SelectedChange(Checked As Boolean)
	Dim rbo As RadioButton
	If Checked=True Then
		rbo=Sender
		txtSoc.text=rbo.Tag
		Main.Soc=txtSoc.text
		Utils.GetCval
		txtCultValue.Text=Main.Cval
	End If
End Sub
		
'add change classification
Sub btnClassn_Action
	ClassnPicker.ClassnStart
End Sub

Sub btnCancel_Action
	frmObjAdd.Close
	Main.Action=1
	
End Sub

Sub btnOk_Action
	Result=True
End Sub

Sub btnOK_MouseClicked (EventData As MouseEvent)
	If txtAccn.text="" Then
		Dim mp As Map: mp.Initialize
	Main.strQuery="Select Prefix from SetUp"
	mp=DBUtils.ExecuteMap(SQL1, Main.strQuery, Null) 
		txtAccn.Text=mp.Get("prefix")	
	End If
	btnOk_Action
End Sub

