﻿Type=StaticCode
Version=4
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Static code module
Sub Process_Globals
	Private fx As JFX
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
'	Dim strType, strLink, strName, strDate, Answ As String
'	Dim CVal As Int
	Dim strQuery As String
	Private cboType, cboLink, cboSelect As ComboBox
	Private lblName,lblTitle, lblSelect As Label
	Private txtDate,txtName As TextField
	Private tvProv1 As TableView
	Private btnDate As Button
	Dim Toast As ToastMessageShow
	Dim SQL1 As SQL
	Dim frmProvUpdate As Form
End Sub


Sub ProvPickerLoad
			
			
			If  	frmProvUpdate.IsInitialized=False Then
					frmProvUpdate.Initialize("frmProvUpdate", 530, 650)
					frmProvUpdate.SetFormStyle("UNIFIED")
					frmProvUpdate.RootPane.LoadLayout("ProvUpdate")
					
					SQL1.InitializeSQLite(File.DirApp, "SCM.db3",False)
			
			'Toast.ToastNotificationOwner = Main.frmProvUpdate
					Toast.Initialize("Toast")
					Toast.ToastIconSize32x32
					Toast.ToastDuration = 6 'Toast.TOAST_LONG_DELAY
					Toast.ToastTextLocation = Toast.TEXT_CENTER
					Toast.ToastLocation= Toast.TOAST_CENTER_RIGHT
					Toast.ToastMessageColor = fx.Colors.Green
					cboType.Items.Addall(Array As String("Event", "Organisation", "Person", "Place"))
					
			End If
			lblTitle.Text=" Add Provenance for "& Main.ObjName
			cboType.Value="Select Type.."
			cboSelect.Value="Select an Entity..."
			cboLink.Value="Select Type first..."
			LoadTvProv1
			frmProvUpdate.show
	
End Sub
Sub cboType_ValueChanged (Value As Object)
	Dim strType As String
	strType=cboType.Value
	cboLink.Value=""
Select strType
	Case "Person" 
		cboLink.Items.AddAll(Array As String("created by", "designed by", "donated by", "given by", "issued to", "owned by", "made by","purchased by", "recieved by", "sold by", "used by","written by"))
		lblName.text="OR Add a Person:"
		lblSelect.Text="Select a Person"
		'fill cboselect
	Case "Organisation"
		cboLink.Items.AddAll(Array As String( "donated by", "given by", "issued by",  "owned by", "published by", "purchased by",  "received by", "revoked by", "sold by", "used by"))
		lblName.text="OR Add Organisation:"
		lblSelect.Text="Select Organisation:"
	Case "Place"
		cboLink.Items.AddAll(Array As String("associated with", "created at", "created in", "designed at", "made at", "used at"))
		lblName.text="OR Add a Place:"
		lblSelect.Text="Select a Place:"
	Case "Event" 
		cboLink.Items.AddAll(Array As String("associated with", "used at"))
		lblName.text="OR Add an Event:"
		lblSelect.Text="Select an Event:"
	Case Else
		Toast.ToastShow("Please select a Provenance Type.")
End Select
strQuery="select distinct linkname, linktype from prov where linktype='" & strType & "'"
DBUtils.ExecuteList(SQL1, strQuery, Null, 0, cboSelect.Items)
End Sub
Sub LoadTvProv1
	       strQuery="SELECT _id, OBJECTID,LinkType as'Link Type',Link,LinkName as 'Linked Entity', LinkDate as 'Link Date',ProvCount FROM Prov Where ObjectID=" & Main.ObjID &" ORDER BY LinkType"
			DBUtils.ExecuteTableview(SQL1,strQuery,Null,0,tvProv1)
			tvProv1.SetColumnVisible(0,False)
			tvProv1.SetColumnVisible(1,False)
			tvProv1.SetColumnWidth(2,75)
			tvProv1.SetColumnWidth(3,85)
			tvProv1.SetColumnWidth(4,220)
			tvProv1.SetColumnWidth(5,80)
			tvProv1.setcolumnvisible(6, False)
			
			
End Sub
Sub btnProv_MouseClicked (EventData As MouseEvent)
Dim mp As Map
mp.Initialize
Dim maps As List
maps.Initialize
Dim btn As Button
btn=Sender
If btn.Tag="1" Then
	'recalculate ProvCount
				Utils.GetProvCount
'add a provenance record
				mp.Put("provcount",Main.PCount)
				If txtName.Text<>"" Then
				mp.Put("linkname",txtName.Text)
				Else
				mp.put("linkName", cboSelect.Value)
				End If
				mp.Put("_id",Null)
				mp.Put("objectid",Main.ObjID)
				mp.Put("linktype",cboType.Value)
				mp.Put("link",cboLink.Value)
				mp.Put("linkdate",txtDate.Text)
				
				maps.Add(mp)

				DBUtils.InsertMaps(SQL1, "Prov", maps)
				
				LoadTvProv1
				Toast.ToastShow("Provenance record saved.")
				cboType.Value="Select Type.."
				cboSelect.Value="Select an Entity..."
				cboLink.Value="Select Type first..."
				txtName.Text=""
				txtDate.Text=""
Else
'Cancel pressed - reset the values
cboType.Value=""
cboLink.Value=""
cboSelect.Value=""
txtName.Text=""
txtDate.Text=""
Main.LoadProvData
frmProvUpdate.Close
End If

End Sub


